#!/bin/sh
# this is simple enough that it can be run for both Mac & Linux
INSTALL_DIR='~/BackupPC_config' # this is the same for Mac (L&T) and Linux
BUPC_USER=%%USERNAME%% # this is substituted on server in turbogears,
# BUPC_HOST has to come from the form bc the host-supplied one via `hostname`
# will often be useless (dchp-32.dept.uci.edu instead of princess.dept.uci.edu)
BUPC_HOST=%%HOSTNAME%%
IPFILENAME=$BUPC_HOST'_'$BUPC_USER'_dhcp'   # for name like 'flop.nac.uci.edu_hjmangalam_dhcp'

UNAME=`uname`
if [ $UNAME = 'Linux' ]; then
  /sbin/ifconfig eth0 |grep 'inet addr'|cut -d':' -f2 |cut -d ' ' -f1  > $INSTALL_DIR/$IPFILENAME
fi
if [ $UNAME = 'Darwin' ]; then
  /sbin/ifconfig en0 |grep 'inet ' |cut -f2 -d' ' > $INSTALL_DIR/$IPFILENAME
fi
IPFILENAME=$BUPC_HOST'_'$BUPC_USER'_dhcp'   # for name like 'flop.nac.uci.edu_hjmangalam_dhcp'

# following assumes that it will be run out of $INSTALL_DIR and puts the
# file into the "alive" share, which will be /etc/BackipPC/alive dir on server.
/usr/bin/rsync --password-file $INSTALL_DIR/rsync.password $INSTALL_DIR/$IPFILENAME ${BUPC_USER}@128.200.84.82::alive
