import turbogears
import locale
from datetime import datetime
from sqlobject import *
from turbogears import controllers, expose, error_handler, validate, flash, redirect, url,widgets, validators, identity
from cherrypy import request
from socket import gethostbyaddr
from  re import sub
from os import mkdir, system, path, getpid
from turbogears import controllers, expose, flash
from IPython.Shell import IPShellEmbed
from Constants import Constants
import model
import sys
#for debugging purposes, can be removed after reaching a stable state.
dbg = IPShellEmbed()

# set the locale so that we can show the date in local format
locale.setlocale(locale.LC_ALL, '')

constants = Constants()

rc_hdrtmplt = constants.getRSyncHeaderTemplate()
rc_stnzatmplt=constants.getTemplateBackup()

Backup_Opts = ("C:\\Documents and Settings", "C:\\Data", "C:\\Backup")

class Services:
	#(L)TODO: rename rc_@!#$%@#$%^ to something more meaningful.
	def execute(self, SLA,IPNUMBER, HOSTNAME,DHCP,WINVER, BACKUP_DIR, FIRSTNAME, LASTNAME,PHONE, USERNAME,PASSWORD1, PASSWORD2, EMAIL, LAPTOP,I_AGREE, debugMode):
		#(L){Q}Google what re is
		import re
		session_date = datetime.now().strftime("%Y%m%dT%H%M%S") # timestamp for session
		strPID = "%s" % (getpid()) # grab the PID in string form
		# separate the files into different batches.
		commonfiles2zip = [
			"cygrunsrv.exe", 
			"cygwin1.dll", 
			"NewEmailInstructions.html", 
			"NewEmailInstructions.txt", 
			"CYGWIN_README.TXT", 
			"rsyncd.exclude", 
			"rsync.exe", 
			"SLA.txt"]
		
		winXPfiles2zip = "winXP_install_rsync.bat"
		
		win2Kfiles2zip = "win2k*"

		#IF DEBUG MODE ADD THE SESSION TO THE USERNAME/IPNUMBER/HOSTNAME
		if debugMode:
			HOSTNAME = HOSTNAME + session_date
			USERNAME = USERNAME + session_date
			IPNUMBER = IPNUMBER + session_date
			
		BUPC_DIRS = ""
		rsyncd_conf = ""
		
		rsyncd_conf_hdr = re.sub('%%USERNAME%%', USERNAME, rc_hdrtmplt)
		rsyncd_conf += rsyncd_conf_hdr

		b_opt = BACKUP_DIR
		laptop = 0
		if LAPTOP == True:
			laptop = 1

		rc_stnza = re.sub('%%BACKUP_PATH%%', Backup_Opts[b_opt], rc_stnzatmplt)
		rsyncd_conf += rc_stnza
		
		rsyncdir = "rsyncd" + strPID + session_date
		try:
			mkdir(rsyncdir)
		except:
			flash(constants.getErrorMkDir(rsyncdir))
			redirect(url('/'))
			
		rsyncdconffile = rsyncdir + "/rsyncd.conf"
		try:
			rcf = open(rsyncdconffile, "w")
			rcf.write(rsyncd_conf)
			rcf.flush()
			print >>sys.stderr, rsyncd_conf
		except:
			flash("file open damaged")
			redirect(url('/'))
			
		rsyncsecretsfile = rsyncdir + "/rsyncd.secrets"
		try:
			rsf = open(rsyncsecretsfile, "w")
			userpass = USERNAME+ ":" + PASSWORD1 + "\n"
			rsf.write(userpass)
			rsf.flush()
		except:
			flash("secrets 'file open' damaged")
		# and finally make sure all the fucking DOS files have DOS
		# end of fucking lines. [Assumes 'todos' from ubuntu repos is available].
		system("todos %s/*rsyncd.*" % (rsyncdir))

		# now copy the COMMON files to the rsyncdir.
		cfiles = ""
		for f in commonfiles2zip: cfiles += f + " "
		cmd = "cd rsync_src && cp " + cfiles + " ../" + rsyncdir
		print >>sys.stderr, cmd
		system(cmd)

		print >>sys.stderr, "About to copy files; WINVER = %i" % WINVER
		
		# if WinXP, cp XP files to the rsyncdir.
		if WINVER == 3 or WINVER == 4:
			cmd = "cd rsync_src && cp " + winXPfiles2zip + " ../" + rsyncdir
			print >>sys.stderr, cmd
			system(cmd)

			# check if we need to add the imalive code (only if XP for right now)
			staticOrDynamic = int(DHCP)
			stringStaticOrDynamicToPrint = "dhcp"
			if staticOrDynamic==0: stringStaticOrDynamicToPrint="static"
			# if it's static, no need to include the imalive checks.
			if staticOrDynamic==1:
				# mod the XP bat file to include the schtask only if dhcp
				scheduleFile = rsyncdir + "/winXP_install_rsync.bat"
				try:
					scheduleFileWriter = open(scheduleFile, "a")
					sched_str= "rem following line inserts the IP # bat file into Windows scheduler\r\nschtasks /Create /SC HOURLY /MO 1 /TN imalive /TR c:\\rsyncd\imalive.bat\r\n"
					scheduleFileWriter.write(sched_str)
					scheduleFileWriter.close()
				except:
					flash("Scheduler file damaged")
				
				batWindowsFile = rsyncdir + "/imalive.bat"
				imalive_fn = HOSTNAME + "_" + USERNAME + "_" +stringStaticOrDynamicToPrint
				try:
					batWindowsFileWriter = open(batWindowsFile, "w")
					#When we attempt to support windows Vista, instead of "IP ADDRESS" we should set it to "IPv4 Address"
					lineToWrite = 'cd c:\\rsyncd'+ "\r\n"+ 'ipconfig |find "IP Address" > ' + imalive_fn + "\r\n"+ "rsync.exe " + imalive_fn + " " + USERNAME +"@128.200.84.82::alive < rsync.password\r\n"

					batWindowsFileWriter.write(lineToWrite)
					batWindowsFileWriter.flush()
				except:
					flash("DHCP configuration file to send damaged")

			
		
		# if Win2k, cp 2K files to the rsyncdir.
		if WINVER == 2:
			cmd = "cd rsync_src && cp " + win2Kfiles2zip + " ../" + rsyncdir
			print >>sys.stderr, cmd
			system(cmd)
			
			
		# NB: assume the BACKUPPC dir, the hosts file, & the htpassword file already exists.
		try:
			mkdir("BACKUPPC")
		except:
			print >>sys.stderr, "The mkdir command failed on BACKUPPC - already exists?"

		# have to write the host config file (host.domain.uci.edu.pl)
		# AND to the 'hosts' file in the SAME common BACKUPPC dir where it
		# later gets copied to the /etc/BackupPC dir
		bupc_hostinfo = """
		$Conf{RsyncdUserName}  = "%s";
		$Conf{RsyncdPasswd}    = "%s";
		$Conf{RsyncShareName}  = [%s];
		""" % (USERNAME, PASSWORD1, "BACKUP")
		fqhostname_file = "/etc/BackupPC/pc/" + HOSTNAME + ".pl"
		print >>sys.stderr, "fqhostname_file = [%s]" % fqhostname_file
		try:
			rsf = open(fqhostname_file, "w")
			rsf.write(bupc_hostinfo) # and that should be it!.
			rsf.close()
		except:
			flash(constants.getErrorInWritingBUPCHostInfoFile())
			
		# now the BackupPC 'hosts' file in the format:
		# # The first non-comment non-empty line gives the field names and should
		# not be edited!!
		#
		#host        dhcp    user    moreUsers     # <--- do not edit this line
		#farside    0       craig   jill,jeff     # <--- example static IP host entry
		#larson     1       bill                  # <--- example DHCP host entry
		hostsline = "%s\t%d\t%s\t#%s\n" % (HOSTNAME, int(DHCP), USERNAME, session_date)
		try:
			rsf = open("/etc/BackupPC/hosts", "a") # "a"ppend to the file
			rsf.write(hostsline)
			rsf.flush()
		except:
			flash(constants.getErrorWritingHostsFile())

		#and write an /etc/hosts-formatted entry into the BackupPC dir
		# in case we have to copy it to /etc/hosts.  This will be rare.
		# Don't want to bugger up the system permissions to allow a rare
		# event.
		shorthostname = HOSTNAME.split('.')[0]
		hostsline = IPNUMBER + '   ' + HOSTNAME + '   ' + shorthostname + '\n'
		try:
			hf = open("/etc/BackupPC/etchosts", "a")
			hf.write(hostsline)
			hf.flush()
		except:
			print >>sys.stderr, "Can't write /etc/BackupPC/etchosts info.  Permissions?!"
			flash("Can't write /etc/BackupPC/etchosts info.  Permissions?!")


		# write the password to the rsyncd/rsync.password file
		passfile = rsyncdir + "/rsync.password"
		try:
			pwWriter = open(passfile, "w")
			pwWriter.write(PASSWORD1 + "\r\n")
			pwWriter.close()
		except:
			flash("Can't write [rsyncd/rsync.password]!!")

		zipflnm = USERNAME + '_' + HOSTNAME + "_rsyncd.zip"  # zipfile to email
		# and finally, mv the temp dir to the canonical one
		system("mv %s rsyncd" % (rsyncdir))
		system("zip %s rsyncd/*" % (zipflnm)) # and zip it

########################  Server side jobs #########################
		# this assumes that the /etc/BackupPC dir is owned by the UID of
		# the user which is running the webbackuppc web service.  Otherwise
		# it will fail.
		# 1st back up the original htpassword with the session date suffix
		system("cp -a /etc/BackupPC/hosts /etc/BackupPC/backup/hosts.%s" %(session_date))
		
		# now write the username and password into the htpassword file so users can
		# access their own accounts.   Write directly to the system BackupPC file
		# so people can access it immediately. 
		system("/usr/bin/htpasswd  -b /etc/BackupPC/htpasswd.4.backuppc %s %s" % (USERNAME, PASSWORD1))

		# the HOSTNAME.pl was already written directly to /etc/BackupPC/pc
		# above when it was created.

		# back up the [/etc/BackupPC/rsyncd.secrets] file and append the new user info
		system("cp -a /etc/BackupPC/rsyncd.secrets  /etc/BackupPC/backup/rsyncd.secrets.%s"%(session_date))
		append_userpass_str = "echo '" + userpass + "' >> /etc/BackupPC/rsyncd.secrets"
		try: system(append_userpass_str)
		except: flash("Can't append to [/etc/BackupPC/rsyncd.secrets]!!")

		# set the email variables for the BUPC CLIENT
		mhtml = "rsync_src/NewEmailInstructions.html"
		mtxt  = "rsync_src/NewEmailInstructions.txt"
		msubj =  constants.getEmailSubject()
		mto = EMAIL
		mailcmd = "mutt -s 'Your BackupPC Configuration files' -a %s -a %s %s < %s" % (zipflnm, mhtml, EMAIL, mtxt)
		print >>sys.stderr, "Sending mail: %s " % (mailcmd)
		system(mailcmd)
		
		# set the email variables for the BUPC ADMIN
		mailcmd = " echo 'Please process this request ASAP!' | mutt -s 'new BackupPC request from %s' -a %s harry.mangalam@uci.edu" % (USERNAME,zipflnm)
		system(mailcmd)
		print >>sys.stderr, "Sending mail: %s " % (mailcmd)
		# and rm the file and the rsync dir
		# system("rm -rf rsyncd %s" % (zipflnm)) # this line rm's the zipfile as well
		system("rm -rf rsyncd")

		#Email Administrator - this composes it, but doesn't actually send it..?
		adminMessageBody= constants.getAdminEmailBody()
		adminMessageSubject = constants.getAdminEmailSubject()
		adminMessageTo = constants.getAdminEmail()
		adminMailCommand = "mutt -s %s -a %s %s < %s "%(adminMessageSubject,zipflnm,adminMessageTo,adminMessageBody)

		# actually, really want the server to return a URL to download the package as well.
		# return a URL as a dict?
		# redirect(url('/download',URL_2_zipfile))

		# (H) this should be done before we send email, no?  Otherwise we're
		# sending possibly erroneous email - ask L
		
		#(L) Create the new register on the database
		try:
			#if it exists, retrieve it
			o=model.owner.byUsername(USERNAME) # user info
		except:
			# if it doesn't exist create it.
			o=model.owner(FirstName=FIRSTNAME,LastName=LASTNAME,UserID=USERNAME, EmailGiven=EMAIL, PhoneNbr=PHONE, Password=PASSWORD1) # user info
		#p.set(IPNbr=IPNUMBER, HostName= HOSTNAME, WinVer=WINVER, DHCP=DHCP, Laptop=laptop, Backup_1=BACKUP_DIR)
		pcinfo = model.pcinfo(owner=o,IPNbr=IPNUMBER,HostName=HOSTNAME,WinVer=WINVER,DHCP=DHCP,Laptop=LAPTOP,Backup_1=BACKUP_DIR)
		#uncomment when sure it is being created.
		#system("rm %s" % (zipflnm))
		redirect(url('/ThankYou'))
