rem  Install a new WinVista service for rsync and start it

cygrunsrv.exe -I rsyncd -e CYGWIN=nontsec -p c:/rsyncd/rsync.exe -a "--config=c:/rsyncd/rsyncd.conf --daemon --no-detach"

cygrunsrv.exe --start rsyncd

rem   Les Stott notes you can setup the WinXP firewall to allow
rem   port 873 TCP connections to rsync with the following script
rem   lines.
rem

rem     sets up the rsync program to talk ONLY to the BackupPC server
netsh firewall set allowedprogram program=c:\rsyncd\rsync.exe name=rsync mode=enable scope=CUSTOM addresses=128.200.84.82

rem     opens port 873 ONLY for the BackupPC server
netsh firewall set portopening protocol=TCP port=873 name=rsyncd mode=enable scope=CUSTOM addresses=128.200.84.82

rem     Sets the Vista firewall to respond to ICMP pings (how the server tells if
rem     clients are on the net).
netsh firewall set icmpsetting type=all mode=enable profile=all

rem     ..Except for "ICMP redirect"
netsh firewall set icmpsetting type=5 mode=disable profile=all

rem     Reduce the size of logging to 128K
netsh firewall set logging maxfilesize=128

