import locale
import socket
#from configobj import ConfigObj# for the configuration module
from datetime import datetime
from turbogears import controllers, expose, error_handler, validate
from turbogears import flash, redirect, url
from turbogears import widgets, validators
from cherrypy import request
from Services import Services
#from MyForms import BackupPCFields
from Constants import Constants
from MyValidators import *
import sys


#from turbogears import widgets, validators
#from Constants import Constants
#from MyValidators import *
#from MyValidators import SecurePassword, TrueValidator, IpValidator, HostValidator, BUPCFormSchema, UsernameValidator

constants = Constants()
class BackupPCFields(widgets.WidgetsList):
    debug = False
#    debug = True
    def setDebug(self,debugMode):
        self.debug = debugMode

    if not debug:
        SLA = widgets.TextArea(label="Service Agreement", default=constants.getSLA(), rows=20, cols=70)
        I_AGREE = widgets.CheckBox(validator=TrueValidator(),label="I agree to the Service Agreement above.")

        IPNUMBER = widgets.TextField(validator=IpValidator(),label="IP #")
        #dbg()
        #try :
            #(hn,alias,ips) = socket.gethostbyaddr(request.remoteAddr)
            #ipAdd= socket.gethostbyname(hn);
        #except:
            #print >>sys.stderr, "blah"
            #ipAdd= request.remoteAddr

        #IPNUMBER=widgets.TextField(name='IPNUMBER', convert=True, field_class='textfield', attrs={'value':ipAdd}, css_classes=[], label="Client IP #")

        HOSTNAME = widgets.TextField(validator=HostValidator(),label="Fully Qualified Hostname [Replace with your PC's]")
        DHCP = widgets.SingleSelectField("DHCP",label="IP Assignment Type",
                                       options=[(0, "Static"),
                                                (1, "DHCP"),],
                                                default=0)
        WINVER = widgets.SingleSelectField("WINVER",label="Windows Version",
                                       options=[(2, "Windows 2000"),
                                                (3, "Windows XP SP1"),
                                                (4, "Windows XP SP2")],
                                                default=4)
        LAPTOP = widgets.CheckBox(label="This PC is a mobile laptop.")

        BACKUP_DIR = widgets.SingleSelectField(label="Which Directory would you like to backup?",
                                       options=[(0, "C:\\Documents and Settings"),
                                                (1, "C:\\Data"),
                                                (2, "C:\\Backup")],
                                                default=0)
        FIRSTNAME = widgets.TextField(validator=validators.PlainText(not_empty=True),attrs={'size':30},label="First name")
        LASTNAME  = widgets.TextField(validator=validators.PlainText(not_empty=True), attrs={'size':30},label="Last name")
        PHONE     = widgets.TextField(validator=validators.NotEmpty(), attrs={'size':30},label="Phone number",default="(949) 824- ")
        USERNAME  = widgets.TextField(attrs={'size':30},label="Select a USERNAME")
        PASSWORD1 = widgets.PasswordField(attrs={'size':15},label="Password (not UCINetID Password)")
        PASSWORD2 = widgets.PasswordField(attrs={'size':15},label="Enter same Password again to verify")
        EMAIL = widgets.TextField(validator=validators.Email(not_empty=True),
                                     attrs={'size':30},label="Email address for notifications")
    else:
        SLA = widgets.TextArea(label="Service Agreement", default=constants.getSLA(), rows=5, cols=70)
        I_AGREE = widgets.CheckBox(label="I agree to the Service Agreement above.")
        IPNUMBER = widgets.TextField(label="IP # [Replace with your PC's]")
        HOSTNAME = widgets.TextField(label="Fully Qualified Hostname [Replace with your PC's]")
        DHCP = widgets.SingleSelectField("DHCP",label="IP Assignment Type",
                                       options=[(0, "STATIC "),
                                                (1, "DHCP"),],
                                                default=0)
        WINVER = widgets.SingleSelectField("WINVER",label="Windows Version",
                                       options=[(2, "Windows 2000"),
                                                (3, "Windows XP SP1"),
                                                (4, "Windows XP SP2")],
                                                default=4)
        LAPTOP = widgets.CheckBox(label="This PC is a mobile laptop.")

        BACKUP_DIR = widgets.SingleSelectField(label="Which Directory would you like to backup?",
                                       options=[(0, "C:\\Documents and Settings"),
                                                (1,"C:\\Data"),
                                                (2, "C:\\Backup")],
                                                default=0)
        FIRSTNAME = widgets.TextField(attrs={'size':30},label="First name")
        LASTNAME  = widgets.TextField(attrs={'size':30},label="Last name")
        PHONE     = widgets.TextField(attrs={'size':30},label="Phone number",default="(949) ")
        USERNAME  = widgets.TextField(attrs={'size':30},label="Select a USERNAME")
        PASSWORD1 = widgets.PasswordField( attrs={'size':15},label="Password (not UCINetID Password)")
        PASSWORD2 = widgets.PasswordField( attrs={'size':15},label="Enter same Password again to verify")
        EMAIL = widgets.TextField(attrs={'size':30},label="Email address for notifications")
