from datetime import datetime
from turbogears.database import PackageHub
from sqlobject import *
#(L){Q} What is this for?
hub = PackageHub('bupc')
__connection__ = hub


class owner(SQLObject):
    FirstName = StringCol(length=20,varchar=True,title="FirstName", dbName="firstname",alternateID=False,default="Joe",unique=False,notNone=True)
    LastName = StringCol(length=30,varchar=True,title="LastName",dbName="lastname", alternateID=False,default="PhD",unique=False,notNone=True)
    UserID = StringCol(length=15,varchar=True,title="UserID",dbName="userid", default="BadUser",notNone=True,unique=True,alternateMethodName="byUsername")
    UciVerified = BoolCol(title="UciVerified",dbName="uciverified",default=False)
    EmailGiven = StringCol(length=30, varchar=True,title="EmailGiven", dbName="emailgiven", default="baduser@uci.edu", alternateID=False,unique=False,notNone=True)
    UciEmail = StringCol(length=20,varchar=True,title="UciEmail",dbName="uciemail",default="uciuser@uci.edu", alternateID=False,unique=False,notNone=False)
    PhoneNbr = StringCol(length=15,varchar=True,title="PhoneNbr",dbName="phonenbr", default="949 999 9999", alternateID=False,unique=False,notNone=True)
    Password = StringCol(length=50,varchar=True,title="Password",dbName="password", default="nopassword", alternateID=False,unique=False,notNone=True)
    DateAdded = DateCol(title="DateAdded",dbName="dateadded", unique=False, notNone=False, default=datetime.now)
   
class pcinfo(SQLObject):
    owner = ForeignKey('owner')    
    IPNbr = StringCol(length=15,varchar=True,title="IPNbr", dbName="ipnbr", default="128.200.000.000", alternateID=True, unique=True,notNone=True,
                                 alternateMethodName='byIP')
    HostName = StringCol(length=40, varchar=True, title="HostName", dbName="hostname", alternateID=True, unique=True,notNone=True,
                                 alternateMethodName='byHost')
    WinVer = StringCol(length=20,varchar=True,title="WinVer",dbName="winver", alternateID=False, default="stupid windows", unique=False,notNone=False)
    DHCP = BoolCol(title="DHCP",dbName="dhcp",default=False)
    Laptop = BoolCol(title="Laptop",dbName="laptop",default=False)
    Backup_1 = StringCol(length=40,varchar=True,title="Backup_1", dbName="backup_1", default="C:\Documents and Settings", alternateID=False, unique=False,notNone=True)
    
   